import numpy as np


def main():
    a = np.exp(1j*2*np.pi/3)
    E = 230
    R = 10
    Zs = 1j*10
    Zm = 1j*5

    print('a)')
    Eabc = E * np.array([1, a**2, a])
    Zabc = np.array([
        [Zs, Zm, Zm],
        [Zm, Zs, Zm],
        [Zm, Zm, Zs]])
    Rabc = np.diag([R, 1e8, 1e8])
    Iabc = np.linalg.solve((Zabc + Rabc), Eabc)
    Uabc = np.matmul(Rabc, Iabc)
    print('Iabc =')
    for u in Iabc:
        print(f'{u:.3f}')
    print('Uabc =')
    for u in Uabc:
        print(f'{u:.3f}')

    print('b)')
    Zd = Zs - Zm
    Zi = Zs - Zm
    Zo = Zs + 2*Zm
    Ia = 3*E/(3*R + Zd + Zi + Zo)
    Ud = E - Zd*Ia/3
    Ui = -Zi*Ia/3
    Uo = -Zo*Ia/3
    Ua = Ud + Ui + Uo
    Ub = a**2*Ud + a*Ui + Uo
    Uc = a*Ud + a**2*Ui + Uo
    print(f'Ia = {Ia:.3f}')
    print(f'Ud = {Ud:.3f}')
    print(f'Ui = {Ui:.3f}')
    print(f'Uo = {Uo:.3f}')
    print(f'Ua = {Ua:.3f}')
    print(f'Ub = {Ub:.3f}')
    print(f'Uc = {Uc:.3f}')


main()
