import numpy as np


def main():
    z = 0.09 + 1j*0.422
    y = 1j*2.62e-6
    S2 = 70 + 1j*23.1
    U2 = 220
    d = 400
    Zc = np.sqrt(z/y)
    gama = np.sqrt(z*y)
    Sn2 = U2**2/np.conj(Zc)
    U1 = U2*(np.cosh(gama*d) + np.conj(S2/Sn2)*np.sinh(gama*d))
    U1_modul = np.abs(U1)
    U1_agol = np.angle(U1)/np.pi*180

    print(f'Zc = {Zc:.3f} Omi')
    print(f'gama = {gama:.6f}')
    print(f'S2 = {S2:.3f} MW')
    print(f'U1 = {U1:.3f} kV')
    print(f'U1_modul = {U1_modul:.3f} kV')
    print(f'U1_agol = {U1_agol:.3f} deg')


main()
