import numpy as np
from scipy.sparse import csr_matrix
from scipy.sparse.linalg import spsolve


def main():
    mreza = np.array([
        [4, 3, 10],
        [3, 1, 20],
        [3, 2, 16],
        [2, 1, 12],
    ])
    generatori = np.array([[4, 2.5]])

    pocetok, kraj, X_gr = mreza[:, 0] - 1, mreza[:, 1] - 1, mreza[:, 2]
    n_gr = pocetok.shape[0]
    n = max(max(pocetok), max(kraj)) + 1

    A1 = csr_matrix((np.ones(n_gr), (range(n_gr), pocetok)), shape=(n_gr, n))
    A2 = csr_matrix((np.ones(n_gr), (range(n_gr), kraj)), shape=(n_gr, n))
    A = A1 - A2
    X_gr_mat = csr_matrix((1/X_gr, (range(n_gr), range(n_gr))))
    Y = A.T * X_gr_mat * A

    i_gen, X_gen = generatori[:, 0] - 1, generatori[:, 1]
    Y = Y + csr_matrix((1/X_gen, (i_gen, i_gen)), shape=(n, n))
    print('Y =', Y)

    kv = 0
    I_jazli = np.zeros(4)
    I_jazli[kv] = 1

    Z = spsolve(Y, I_jazli)
    print('Z =', Z)

    Jd = 110/np.sqrt(3)/Z[kv]
    print(f'Jd = {Jd:.3f} kA')

    Ud = 110/np.sqrt(3) - Z*Jd
    print('Ud =')
    for u in Ud:
        print(f'{u:10.3f}')

    Id = A * Ud/X_gr
    print('Id =')
    for i in Id:
        print(f'{i:10.3f}')


main()
