import numpy as np
import matplotlib.pyplot as plt
from rk4 import rk4

R = 3.6
L = 0.57
C = 100e-6
E = 12


def RLC(t, y):
    d = np.array([
        (E - R*y[0] - y[1])/L,
        y[0]/C
    ])
    return d


def main():
    [t, y] = rk4(RLC, 0, 1, [0, 0], 1000)
    plt.subplot(2, 1, 1)
    plt.plot(t, y[:, 0], '-r')
    plt.subplot(2, 1, 2)
    plt.plot(t, y[:, 1], '-b')
    plt.show()


main()
